//
//  IndexDocument.m
//  IndexView2
//
//  Created by KOYAMA Yoshiaki on Sat Apr 17 2004.
//  Copyright (c) 2004 KOYAMA Yoshiaki. All rights reserved.
//

#import "IndexDocument.h"
#import "Controller.h"

@implementation IndexDocument

#pragma mark -
#pragma mark /// IndexDocument ///

- (id)init {
    self = [super init];

    if (self) {
		_data = nil;
		_textString = nil;
		_newFlag = YES;
    }
    return self;
}

- (NSString *)windowNibName {
    return @"IndexDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController {
	NSString *path;
    NSString *lastpath;
    NSString *fullPath;
    NSBundle *bundle;
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	int encoding;

 //   [super windowControllerDidLoadNib:aController];

    bundle = [NSBundle mainBundle];
    path = [bundle bundlePath];
    
    path = [path stringByDeletingLastPathComponent];
    
    lastpath = [path lastPathComponent];

    if ([lastpath isEqualToString:@"build"] == YES)
        path = [path stringByDeletingLastPathComponent];    

    fullPath = [path stringByAppendingPathComponent:FILE_NAME];

	if ((_textString == nil) && (_newFlag == YES)) {
		encoding = [defaults integerForKey:@"Encoding"];
		if (encoding == 0) {
			encoding = NSUTF8StringEncoding;
		}

		_data = [[NSData dataWithContentsOfFile:fullPath] retain];
		_textString = [[NSString alloc] initWithData:_data encoding:encoding];

		if (_textString == nil) {
			_textString = @"";
		}
		
		[_textString retain];

		[self setLastComponentOfFileName:FILE_NAME];
	}

	[_controller makeTitle];
	[_textView setString:_textString];

}

- (NSData *)dataRepresentationOfType:(NSString *)aType {
    return nil;
}

- (BOOL)loadDataRepresentation:(NSData *)data ofType:(NSString *)aType {
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	int encoding;

	encoding = [defaults integerForKey:@"Encoding"];
	if (encoding == 0) {
		encoding = NSUTF8StringEncoding;
	}

	_newFlag = NO;
	if (data == nil) {
//		_data = nil;
//		_textString = nil;
	} else {
		_data = data;
		[_data retain];
		_textString = [[NSString alloc] initWithData:data encoding:encoding];
	}

	if (_textString == nil) {
		_textString = @"";
		[_textString retain];
	}
	
	return YES;
}

#pragma mark -
#pragma mark /// ǂݍ܂ꂽeLXg ///

- (NSString *)textString {
	return _textString;
}

@end
