//
//  MainController.m
//  IndexView2
//
//  Created by KOYAMA Yoshiaki on Thu Apr 22 2004.
//  Copyright (c) 2004 KOYAMA Yoshiaki. All rights reserved.
//

#import "MainController.h"

@implementation MainController

#pragma mark -
#pragma mark /// Init ///

- (id)init {
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];

    self = [super init];

    if (self) {
		[defaults setInteger:1 forKey:@"New"];
		[defaults synchronize];
    }
    return self;
}

- (void)awakeFromNib {
	NSFont *aFont = [NSFont fontWithName:@"HiraKakuPro-W3" size:10];
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	int code;
	int document;

	code = [defaults integerForKey:@"Encoding"];
	[_encodingPopUpButton selectItemAtIndex:code];

	document = [defaults integerForKey:@"Document"];
	if (document == 0) {
		[_switch setState:NSOnState];
	} else {
		[_switch setState:NSOffState];
	}

	[_encodingPopUpButton setFont:aFont];

	[_prefsWindow center];
}

#pragma mark -
#pragma mark /// MyDocument ///

// VKɃhLg쐬Ȃ
- (BOOL)applicationShouldOpenUntitledFile:(NSApplication *)sender {
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	int document;
	document = [defaults integerForKey:@"Document"];

	if (document == 0) {
		return YES;
	} else {
		return NO;
	}
}

#pragma mark -
#pragma mark /// Preferences ///

- (IBAction)setEncoding:(id)sender {
	int code;
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];

    code = [_encodingPopUpButton indexOfSelectedItem];
    [defaults setInteger:code forKey:@"Encoding"];

    [defaults synchronize];
}

- (IBAction)setDocument:(id)sender {
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];

    if ([_switch state] == NSOnState) {
		[defaults setInteger:0 forKey:@"Document"];
	} else {
		[defaults setInteger:1 forKey:@"Document"];
	}

    [defaults synchronize];
}

@end
