//
//  MyDocument.m
//  IndexView2
//
//  Created by KOYAMA Yoshiaki on Fri Apr 23 2004.
//  Copyright (c) 2004 KOYAMA Yoshiaki. All rights reserved.
//

#import "MyDocument.h"
#import "MyDocumentController.h"

@implementation MyDocument

#pragma mark -
#pragma mark /// MyDocument ///

- (id)init
{
    self = [super init];
    if (self) {
		_data = nil;
		_textString = nil;
		_newFlag = YES;    
    }
    return self;
}

- (NSString *)windowNibName
{
	return @"MyDocument";
}

- (void)windowControllerDidLoadNib:(NSWindowController *) aController
{
	NSString *path;
    NSString *lastpath;
    NSString *fullPath;
    NSBundle *bundle;
    NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	NSFileManager *manager = [NSFileManager defaultManager];
	int encoding;
	int intNew;
	int intDocument;
	BOOL exist;

    [super windowControllerDidLoadNib:aController];

    bundle = [NSBundle mainBundle];
    path = [bundle bundlePath];
    
    path = [path stringByDeletingLastPathComponent];
    
    lastpath = [path lastPathComponent];

    if ([lastpath isEqualToString:@"build"] == YES)
        path = [path stringByDeletingLastPathComponent];    

    fullPath = [path stringByAppendingPathComponent:FILE_NAME];

	exist = [manager fileExistsAtPath:fullPath];

	intNew = [defaults integerForKey:@"New"];
	intDocument = [defaults integerForKey:@"Document"];

	if (intDocument == 0) {
		if ((_textString == nil) && (_newFlag == YES) && (intNew == 1) && (exist == YES)) {
			encoding = [defaults integerForKey:@"Encoding"];
			if (encoding == 0) {
				encoding = NSUTF8StringEncoding;
			}

			_data = [[NSData dataWithContentsOfFile:fullPath] retain];
			_textString = [[NSString alloc] initWithData:_data encoding:encoding];

			if (_textString == nil) {
				_textString = @"";
			}
		
			[_textString retain];

			//[self setLastComponentOfFileName:FILE_NAME];
			[self setFileName:fullPath];
			[defaults setInteger:0 forKey:@"New"];
			[defaults synchronize];

		} else {
			if (_textString == nil) {
				_textString = @"";
			}
			[_textString retain];
		}
	} else {
		if (_textString == nil) {
			_textString = @"";
		}
		[_textString retain];
	}

	if ((_data != nil) && (intNew == 1)) {
		[defaults setInteger:0 forKey:@"New"];
		[defaults synchronize];
	}

	[_textView setString:_textString];
	[_myDocumentController makeTitle];

}

- (NSData *)dataRepresentationOfType:(NSString *)aType
{
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	unsigned encoding;
	int code;
	NSData *data;

	code = [defaults integerForKey:@"Encoding"];
	encoding = [self encoding:code];

	data = [[_textView string] dataUsingEncoding:encoding allowLossyConversion:NO];

    return data;
}

- (BOOL)loadDataRepresentation:(NSData *)data ofType:(NSString *)aType
{
	NSUserDefaults *defaults = [NSUserDefaults standardUserDefaults];
	unsigned encoding;
	int code;

	code = [defaults integerForKey:@"Encoding"];
	encoding = [self encoding:code];

	_newFlag = NO;
	_data = data;
	[_data retain];
	_textString = [[NSString alloc] initWithData:data encoding:encoding];

	if (_textString == nil) {
		_textString = @"";
		[_textString retain];
	}
	
	return YES;
}

- (void)printDocument:(id)sender {

    NSPrintOperation *op = [NSPrintOperation
		printOperationWithView:_textView
		printInfo:[self printInfo]];

    [op runOperationModalForWindow:_documentWindow
                delegate:self
                didRunSelector:
                    @selector(printOperationDidRun:success:contextInfo:)
                contextInfo:NULL];
}


- (void)printOperationDidRun:(NSPrintOperation *)printOperation
                success:(BOOL)success
                contextInfo:(void *)info {
    if (success) {

        // Can save updated NSPrintInfo, but only if you have

        // a specific reason for doing so

        // [self setPrintInfo: [printOperation printInfo]];
    }

}

#pragma mark -
#pragma mark /// eLXg ///

- (NSString *)textString {
	return _textString;
}

#pragma mark -
#pragma mark /// encoding ///

- (unsigned)encoding:(int)number {
	unsigned encoding;

	switch (number) {
		case 0:
		encoding = NSUTF8StringEncoding; // UTF-8
		break;
		case 1:
		encoding = NSShiftJISStringEncoding; // Shift JIS
		break;
		case 2:		
		encoding = NSJapaneseEUCStringEncoding; // EUC
		break;
		case 3:
		encoding = NSUnicodeStringEncoding; // UTF-16
		break;
		default:
		encoding = NSUTF8StringEncoding;
		break;		
	}

	return encoding;
}

@end
