//
//  MyDocumentController.m
//  IndexView2
//
//  Created by KOYAMA Yoshiaki on Fri Apr 23 2004.
//  Copyright (c) 2004 KOYAMA Yoshiaki. All rights reserved.
//

#import "MyDocumentController.h"
#import "MyDocument.h"

static NSString *IndexToolbarIdentifier = @"Index Toolbar";
static NSString *DrawerToolbarItemIdentifier = @"Drawer ToolbarItem";

// r̊֐
NSComparisonResult CompareClassIndex(id element1, id element2, void *context) {
	NSNumber *valueNumber1;
	NSString *valueTitle1;
	NSDictionary *dictionary1;
	NSNumber *valueNumber2;
	NSString *valueTitle2;
	NSDictionary *dictionary2;
	NSComparisonResult result1;
	NSComparisonResult result2;

	dictionary1 = element1;
	valueNumber1 = [dictionary1 objectForKey:@"Number"];
	valueTitle1 = [dictionary1 objectForKey:@"Title"];

	dictionary2 = element2;
	valueNumber2 = [dictionary2 objectForKey:@"Number"];
	valueTitle2 = [dictionary2 objectForKey:@"Title"];

	result1 = [valueTitle1 compare:valueTitle2];
	result2 = [valueNumber1 compare:valueNumber2];

	if (result1 == NSOrderedSame) {
		return result2;
	} else {
		return result1;
	}
}

@implementation MyDocumentController

#pragma mark -
#pragma mark /// Nib ///

// Toolbar̍쐬
- (void)awakeFromNib {
    NSTableColumn *column;
	NSCell *cell;
	NSFont *aFont = [NSFont fontWithName:@"HiraKakuPro-W3" size:10];
	
	[self initializeToolbar];
	[_textView setFont:aFont];

	column = [_tableView tableColumnWithIdentifier:@"Number"];
    cell = [column dataCell];
	[cell setFont:aFont];

	column = [_tableView tableColumnWithIdentifier:@"Title"];
    cell = [column dataCell];
	[cell setFont:aFont];

	[_textView setUsesFontPanel:YES];
}

#pragma mark -
#pragma mark /// Toolbar ///
 
// Toolbaȑ
- (void)initializeToolbar {
    NSToolbar *toolbar = [[NSToolbar alloc] initWithIdentifier:IndexToolbarIdentifier];

    [toolbar setAllowsUserCustomization:YES];
    [toolbar setAutosavesConfiguration:YES];
    [toolbar setDisplayMode:NSToolbarDisplayModeIconOnly];
    [toolbar setDelegate:self];
    [_window setToolbar:toolbar];
    [toolbar release];
}


- (NSToolbarItem *)toolbar:(NSToolbar *)toolbar
	itemForItemIdentifier:(NSString *)itemIdent
	willBeInsertedIntoToolbar:(BOOL)willBeInserted
 {
    NSToolbarItem *toolbarItem = [[NSToolbarItem alloc] initWithItemIdentifier:itemIdent];

    [toolbarItem autorelease];
    
	if([itemIdent isEqual:DrawerToolbarItemIdentifier]) {
        [toolbarItem setLabel: @"Drawer"];
        [toolbarItem setPaletteLabel: @"Drawer"];
        [toolbarItem setToolTip:@"Drawer"];
        [toolbarItem setImage:[NSImage imageNamed: @"Drawer"]]; //32*32
        [toolbarItem setTarget: self];
        [toolbarItem setAction: @selector(toggleDrawer:)];
	} else {
        return nil;
    }
	
    return toolbarItem;
}

- (NSArray *)toolbarDefaultItemIdentifiers:(NSToolbar *)toolbar {
    return [NSArray arrayWithObjects:
		DrawerToolbarItemIdentifier, 
        NSToolbarFlexibleSpaceItemIdentifier,
        NSToolbarCustomizeToolbarItemIdentifier, nil];
}

- (NSArray *)toolbarAllowedItemIdentifiers:(NSToolbar *)toolbar
{ 
    return [NSArray arrayWithObjects:
        DrawerToolbarItemIdentifier,
//		NSToolbarPrintItemIdentifier, NSToolbarShowColorsItemIdentifier,
//		NSToolbarShowFontsItemIdentifier, 
		NSToolbarCustomizeToolbarItemIdentifier,
        NSToolbarFlexibleSpaceItemIdentifier, NSToolbarSpaceItemIdentifier,
        NSToolbarSeparatorItemIdentifier, nil];
}

- (void)toolbarWillAddItem:(NSNotification *)notification
{ 
    NSToolbarItem *addedItem = [[notification userInfo] objectForKey: @"item"];
    if ([[addedItem itemIdentifier] isEqual:DrawerToolbarItemIdentifier]) {
    }
}

- (void)toolbarDidRemoveItem:(NSNotification *)notification { 
/*
    NSToolbarItem *removedItem = [[notification userInfo] objectForKey: @"item"];
   if (removedItem == item) {
    }
*/
}

// Toolbar̗LE̔f
- (BOOL)validateToolbarItem:(NSToolbarItem *)toolbarItem {

	if ([[toolbarItem itemIdentifier] isEqual:DrawerToolbarItemIdentifier]) {
	}
		
	return YES;
}

#pragma mark -
#pragma mark /// NSDrawer ///

- (void)toggleDrawer:(id)sender {
	[_drawer toggle:self];
}

#pragma mark -
#pragma mark /// Index ///

- (void)makeTitle {
	NSScanner *scan;
    NSCharacterSet *set;
    NSString *str;
	NSString *indexStr;
	NSString *iStr;
	NSString *textString;
	NSNumber *valueNumber;
	NSString *valueTitle;
	NSDictionary *dictionary;
	
	int count = 1;
	BOOL flag = YES;

//	textString = [_document textString];
	textString = [_textView string];

	if ((textString == nil) || ([textString isEqualToString:@""] == YES))
		return;
	[_array release];
	_array = [[NSMutableArray array] retain];
	
    scan = [NSScanner scannerWithString:textString];
    set = [NSCharacterSet characterSetWithCharactersInString:@"\n\r"];
	indexStr = NSLocalizedString(@"INDEX",@"");

    do {
        flag = [scan scanUpToCharactersFromSet:set intoString:&str];
		iStr = [str substringToIndex:1];

		if ([iStr isEqualToString:indexStr] == YES) {
			valueNumber = [NSNumber numberWithInt:count];
			valueTitle = [str substringFromIndex:1];
			dictionary = [NSDictionary dictionaryWithObjectsAndKeys:
							valueNumber, @"Number", valueTitle, @"Title", nil];
			[_array addObject:dictionary];
			count++;
		}

    } while (flag == YES);

	[_array sortUsingFunction:CompareClassIndex context:NULL];	
	[_tableView reloadData];

}

#pragma mark -
#pragma mark /// NSTableView ///

// I
- (BOOL)tableView:(NSTableView *)aTableView shouldSelectRow:(int)rowIndex {
    NSRange aRange;
    NSString *aString;
    
    if (rowIndex < [_array count]) {
        aString = [_textView string];    
        aRange = [aString rangeOfString:[self readTitle:rowIndex]];
          
        if (aRange.location != NSNotFound) {
            [_textView setSelectedRange:aRange];
            [_textView scrollRangeToVisible:aRange];
        }
    }
    return YES;
}

// NSTableDataSource
- (int)numberOfRowsInTableView:(NSTableView *)aTableView {
    return [_array count];
}

- (id)tableView:(NSTableView *)aTableView
objectValueForTableColumn:(NSTableColumn *)aTableColumn
row:(int)rowIndex
{    
   if (rowIndex >= 0 && rowIndex < [_array count]) {
        if ([[aTableColumn identifier] isEqual:@"Number"])
            return [self readNumber: rowIndex];
        else if ([[aTableColumn identifier] isEqual:@"Title"])
            return [self readTitle: rowIndex];

    }
    return nil;
}

- (id)readNumber: (int) rowIndex {
    NSNumber *number;
	NSDictionary *dictionary;
    
    if (rowIndex < [_array count]) {
		dictionary = [_array objectAtIndex:rowIndex];
		number = [dictionary objectForKey:@"Number"];
        return number;
    } else
        return nil;

}

- (id)readTitle: (int) rowIndex {
    NSString *title;
	NSDictionary *dictionary;

    if (rowIndex < [_array count]) {
		dictionary = [_array objectAtIndex:rowIndex];
		title = [dictionary objectForKey:@"Title"];

        return title;
    } else
        return nil;
}

#pragma mark -
#pragma mark /// NSText ///

- (void)textDidChange:(NSNotification *)aNotification {
	[self makeTitle];
	[_tableView reloadData];
}

@end
